Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4Quasmon.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4Quasmon.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4Quasmon.cc	(revision 1055)
@@ -28,11 +28,32 @@
 //
 //
-// $Id: G4Quasmon.cc,v 1.107 2008/03/31 20:30:35 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4Quasmon.cc,v 1.111 2009/05/27 08:53:15 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //      ---------------- G4Quasmon ----------------
 //             by Mikhail Kossov, July 1999.
 //  class for an excited hadronic state used by the CHIPS Model
-// ------------------------------------------------------------
+// ---------------------------------------------------------------------------
+// Short description: The Quasmon is the main object of the CHIPS model, where
+// hadronic states are defined by the quark content and the 4-momentum (mass).
+// In this sense a Quasmon is a generalised hadron - hadrons are the low
+// mass discrete states of quasmons. Here the hadron can be not only an
+// elementary particle, consisting of   2 or 3 quarks, but a nucleonic
+// cluster, consisting of 6, 9, ... , 3n, ... quarks. In the CHIPS model
+// the nucleus is considered as a group of the nucleons and the nucleonic
+// clusters. In hadronic reactions a Quasmon is constructed in vacuum as
+// a result of the collision (G4QCollision process). In this case only
+// the G4Quasmon class can be used for the reaction. In nuclear reactions
+// one or a few Quasmons can be created as a result of the colision of
+// the projectile hadrons with the nucleons and the nucleonic clusters
+// of the nuclear target. In this case the Quasmons are created and
+// fragmented in the nuclear environment (G4QNucleus) and the G4QEnvironment
+// class must be used for the reaction. For nuclear-nuclear reactions
+// two G4QEnvironments are used with the common (which can fragment in both
+// nuclear environments - mostly at low energies), individual (which can
+// fragment in only one of two G4QEnvironments) and vacuum (which can
+// fragment in vacuum being too far by rapidity from both nuclei) Quasmons.
+// --------------------------------------------------------------------------
+//
 //#define debug
 //#define pdebug
@@ -287,5 +308,5 @@
   {
 #ifdef debug
-	   G4cout<<"G4Q::HQ: PionAtRest, addP="<<addPhoton<<", momP="<<momPhoton<<G4endl;
+    G4cout<<"G4Q::HQ: PionAtRest, addP="<<addPhoton<<", momP="<<momPhoton<<G4endl;
 #endif
     addPhoton=0.;
@@ -330,8 +351,8 @@
 #endif
     if(addPhoton)
-	   {
-	     G4cerr<<"***G4Quas::HQ:Q4M="<<q4Mom<<",status="<<status<<", phE="<<addPhoton<<G4endl;
+    {
+      G4cerr<<"***G4Quas::HQ:Q4M="<<q4Mom<<",status="<<status<<", phE="<<addPhoton<<G4endl;
       throw G4QException("G4Quasmon::HadronizeQuasmon: OverheadPhoton for theZeroQuasmon");
-	   }
+    }
     KillQuasmon();                         // This Quasmon is done
     qEnv=theEnvironment;                   // Update QEnvironment
@@ -386,5 +407,5 @@
     if(nHd) for(int ih=0; ih<nHd; ih++) ccSum+=theQHadrons[ih]->GetCharge();
     if(ccSum!=cSum)
-	   {
+    {
       G4cerr<<"*G4Q::HQ:C"<<cSum<<",c="<<ccSum<<",E="<<theEnvironment<<",Q="<<valQ<<G4endl;
       G4cerr<<":G4Q::HQ:oldE="<<oldEnv<<"oldQ="<<oldCQC<<",oN="<<oldNH<<",N="<<nHd<<G4endl;
@@ -405,10 +426,10 @@
     G4double tmpPq=q4Mom.rho();            // Momentum of Quasmon
     if(fabs(qM2)<.0001 || tmpEq<=tmpPq)
-	   {
+    {
       qM2=0.;
       if(!valQ.GetCharge() && !valQ.GetBaryonNumber() && !valQ.GetStrangeness())
       {
         if(fabs(qM2)<.001)
-	       {
+        {
           q4Mom.setE(tmpPq);
 #ifdef debug
@@ -420,7 +441,7 @@
           qEnv=theEnvironment;             // Update QEnvironment
           return theQHadrons;              // The last decay of the quasmon... 
-	       }
+        }
         else if(tmpPq<.001)                // @@ Unprobable...
-	       {
+        {
 #ifdef debug
           G4cout<<"G4Q::HQ:Quasmon is nothing, Q4M="<<q4Mom<<",E="<<theEnvironment<<G4endl;
@@ -429,5 +450,5 @@
           qEnv=theEnvironment;             // Update QEnvironment
           return theQHadrons;              // The last act of the quasmon... 
-	       }
+        }
       }
       else q4Mom.setE(tmpPq*1.00001);      // @@ Can break E/p conservation
@@ -438,5 +459,5 @@
     //////////G4double b2=qltb.mag2();                       // beta^2 of Quasmon
 #ifdef debug
-	   G4cout<<"G4Q::HQ: Quasm="<<q4Mom<<",qM="<<quasM<<",qQC="<<valQ<<G4endl;
+    G4cout<<"G4Q::HQ: Quasm="<<q4Mom<<",qM="<<quasM<<",qQC="<<valQ<<G4endl;
 #endif
     CalculateNumberOfQPartons(quasM);      // Fills PrivateParameter nOfQ (a#OfQPartonsInQ)
@@ -449,10 +470,10 @@
     //G4int maxActEnv=4;   // n-Dod + p-Dod  // maxEnv.(in d) to compensate the Q recoilMom
     G4int maxActEnv=256; // n-Dod + p-Dod  // maxEnv.(in d) to compensate the Q recoilMom
-    G4int dmaxActEnv=maxActEnv+maxActEnv;  // 2maxEnv.(in d) to compensate the Q recoilMom
+    G4int dmaxActEnv=maxActEnv+maxActEnv;  // 2*maxEnv.(in d) to compensate the Q recoilMom
     //G4double fAE=static_cast<double>(maxActEnv);
-	   if(envA>dmaxActEnv)
-				//if(2>3)                              // Corresponds to envA>256
-	   {
-	     //G4int oEn=static_cast<int>(fAE/sqrt(static_cast<double>(envA)));
+    if(envA>dmaxActEnv)
+    //if(2>3)                              // Corresponds to envA>256
+    {
+      //G4int oEn=static_cast<int>(fAE/sqrt(static_cast<double>(envA)));
       G4int zEn=maxActEnv;                 // Charge of the LimitActiveNuclearEnvironment
       G4int nEn=zEn;                       // Charge of the LimitActiveNuclearEnvironment
@@ -461,7 +482,7 @@
       bEn4M=G4LorentzVector(0.,0.,0.,mbEn);// 4-momentum of the LimitActiveNuclearEnviron
       bEnQC=G4QContent(bEn+nEn,bEn+zEn,0,0,0,0); // QuarkContent of the LimitActiveNuclEnv
-	   }
+    }
     else                                   // @@ Can be made STATIC CONSTANTS
-	   {
+    {
       bEn   = 256;                         // BaryoN of the LimitActiveNuclearEnvironment
       mbEn  = G4QPDGCode(2112).GetNuclMass(128,128,0); // Mass of the LimActNucEnvironment
@@ -472,5 +493,5 @@
     G4QContent envQC=theEnvironment.GetQCZNS(); // QuarkContent of theCurrentNuclearEnviron
 #ifdef debug
-	   G4cout<<"G4Q::HQ: ePDG="<<envPDG<<",eM="<<envM<<",eQC="<<envQC<<G4endl;
+    G4cout<<"G4Q::HQ: ePDG="<<envPDG<<",eM="<<envM<<",eQC="<<envQC<<G4endl;
 #endif
     G4QContent totQC=valQ+envQC;           // Total Quark Content
@@ -483,5 +504,5 @@
     G4double totM  =totN.GetMZNS();        // Minimum Mass of the Total System
 #ifdef debug
-	   G4cout<<"G4Q::HQ: tN="<<totN<<",tGSM="<<totM<<",tQC="<<totQC<<G4endl;
+    G4cout<<"G4Q::HQ: tN="<<totN<<",tGSM="<<totM<<",tQC="<<totQC<<G4endl;
 #endif
     /////////////////////G4double protCB=theEnvironment.CoulombBarrier(1.,1.);
@@ -489,10 +510,10 @@
     G4double resNM =10000000.;             // Prototype of residual mass after n separated
     if(totNeut>0)
-	   {
+    {
       G4QContent resNQC=totQC-G4QContent(2,1,0,0,0,0);
       G4QNucleus resNN(resNQC);
       resNM  = resNN.GetMZNS();
       resNPDG= resNN.GetPDG();
-	   }
+    }
     G4LorentzVector env4M =G4LorentzVector(0.,0.,0.,envM);
     G4LorentzVector tot4M =q4Mom+env4M;
@@ -500,9 +521,9 @@
     G4int    totPDG=totN.GetPDG();         // Total PDG Code for the Current compound
 #ifdef debug
-	   G4cout<<"G4Q::HQ: totPDG="<<totPDG<<",totM="<<totMass<<",rPDG="<<resNPDG<<G4endl;
+    G4cout<<"G4Q::HQ: totPDG="<<totPDG<<",totM="<<totMass<<",rPDG="<<resNPDG<<G4endl;
 #endif
     G4double totEn=tot4M.e();
-				G4double totMo=tot4M.rho();
-	   if(totEn<totMo)
+    G4double totMo=tot4M.rho();
+    if(totEn<totMo)
     {
       G4cerr<<"---Warning---G4Q::HQ: *Boost* tot4M="<<tot4M<<", E-p="<<totEn-totMo<<G4endl;
@@ -510,8 +531,8 @@
       G4double emodif=fabs(totEn-totMo);
       //if(emodif<accuracy)
-						//{
+      //{
         G4cerr<<"G4Q::HQ: *Boost* E-p shift  is corrected to "<<emodif<<G4endl;
         tot4M.setE(totMo+emodif+.01*accuracy);
-						//}
+      //}
     }
     G4ThreeVector totBoost = tot4M.boostVector(); // BoostVector for TotalSystem (backward)
@@ -524,5 +545,5 @@
     G4int    iniS   =valQ.GetL();
 #ifdef debug
-	   G4cout<<"G4Q::HQ: iniPDG="<<iniPDG<<", Z="<<iniP<<", N="<<iniN<<", S="<<iniS<<G4endl;
+    G4cout<<"G4Q::HQ: iniPDG="<<iniPDG<<", Z="<<iniP<<", N="<<iniN<<", S="<<iniS<<G4endl;
 #endif
     G4QNucleus iniRN(iniP,iniN-1,iniS);
@@ -531,5 +552,5 @@
     G4double iniQM =G4QPDGCode(iniPDG).GetMass();  // Minimum mass of Quasmon
 #ifdef debug
-	   G4cout<<"G4Q::HQ: iniRN="<<iniRN<<", iniRM="<<iniRM<<", iniQM="<<iniQM<<G4endl;
+    G4cout<<"G4Q::HQ: iniRN="<<iniRN<<", iniRM="<<iniRM<<", iniQM="<<iniQM<<G4endl;
 #endif
     /////////////////G4double iniQM2= iniQM*iniQM;
@@ -558,5 +579,5 @@
     //theEnvironment.PrepareCandidates(theQCandidates,false,false);//Calc.PrePreprob's of C
     //G4bool fF=piF||gaF;
-	   // piF,piF or gaF,gaF is correct. Made to avoid theSpecificInteractionTimeClusterChoice
+    // piF,piF or gaF,gaF is correct. Made to avoid theSpecificInteractionTimeClusterChoice
     theEnvironment.PrepareCandidates(theQCandidates,piF,piF);// Calc.PrePreprob of Candid's
     ModifyInMatterCandidates();            // Calculate InMediaMasses of Cand. & Possibil.
@@ -596,24 +617,24 @@
       kCountMax=pCountMax;
     }
-	   G4bool gintFlag=false;                // Flag of gamma interaction with one quark
-	   while(kCount<kCountMax&&kCond)
-	   {
+    G4bool gintFlag=false;                // Flag of gamma interaction with one quark
+    while(kCount<kCountMax&&kCond)
+    {
       kCond=true;
       G4double miM2=0.;
       if(envPDG==NUCPDG)
-	     {
+      {
         if(excE>mPi0) miM2=mPi02;
         else          miM2=mP2;
-	     }
+      }
       else                                // "Env. exists" case - find k_min & k_max
-	     {
+      {
         minK=100000.;
         // @@ ??? May be for the light nuclei ???
         //if(piF&&quasM>iniQM) maxK=mNeut/2.+(quasM-iniQM)*iniQM/(iniQM+mNeut);
         //else if(quasM>iniQM)
-		      //{
+        //{
         //  G4double limK=envM/2.+(quasM-iniQM)*iniQM/(iniQM+envM);
         //  if(limK<maxK) maxK=limK;
-		      //}
+        //}
         //@@*acceleration*: check only for P,N,d,& alpfa, can be done for all clusters(?)
         //if(iniN>0&&iniBN>1)               // "Neutron-hadron" estimate
@@ -634,5 +655,5 @@
         //    G4double dkts=kts+kts;
         //    G4double fu=dkts*(dkts*quasM-sm2)+quasM*m2N;
-	       //    G4cout<<"G4Q::HQ:M="<<quasM<<",R="<<bnRQ<<",f("<<kts<<")="<<fu<<"<0"<<G4endl;
+        //    G4cout<<"G4Q::HQ:M="<<quasM<<",R="<<bnRQ<<",f("<<kts<<")="<<fu<<"<0"<<G4endl;
 #endif
         //    if(quasM>=mNeut+bnRQ)
@@ -653,12 +674,12 @@
         if(totN>0&&totBN>1)               // "Neutron-cluster" estimate
         {
-		        G4QNucleus tmpNN(totZ,totN-1,0);
+          G4QNucleus tmpNN(totZ,totN-1,0);
           G4double delN=tmpNN.GetMZNS()+mNeut-totM;
           if(envN>0&&envA>1)
           {
-			         G4QNucleus envNN(envZ,envN-1,0);
+            G4QNucleus envNN(envZ,envN-1,0);
             G4double delEN=envNN.GetMZNS()+mNeut-envM;
             if(delEN>delN) delN=delEN;
-		        }
+          }
           delN*=qurF;
           if(delN<minK) minK=delN;
@@ -667,12 +688,12 @@
         {
           G4double proCB=theEnvironment.CoulombBarrier(1,1);
-		        G4QNucleus tmpPN(totZ-1,totN,0);
+          G4QNucleus tmpPN(totZ-1,totN,0);
           G4double delP=tmpPN.GetMZNS()+mProt-totM+proCB;
           if(envZ>0&&envA>1)
           {
-			         G4QNucleus envPN(envZ-1,envN,0);
+            G4QNucleus envPN(envZ-1,envN,0);
             G4double delEP=envPN.GetMZNS()+mProt-envM+proCB;
             if(delEP>delP) delP=delEP;
-		        }
+          }
           delP*=qurF;
           if(delP<minK) minK=delP;
@@ -681,12 +702,12 @@
         {
           G4double proCB=theEnvironment.CoulombBarrier(1,2);
-		        G4QNucleus tmpDN(totZ-1,totN-1,0);
+          G4QNucleus tmpDN(totZ-1,totN-1,0);
           G4double delD=tmpDN.GetMZNS()+mDeut-totM+proCB;
           if(envN>0&&envZ>0&&envA>2)
           {
-		          G4QNucleus envDN(envZ-1,envN-1,0);
+            G4QNucleus envDN(envZ-1,envN-1,0);
             G4double delED=envDN.GetMZNS()+mDeut-envM+proCB;
             if(delED>delD) delD=delED;
-		        }
+          }
           delD*=qurF;
           if(delD<minK) minK=delD;
@@ -695,12 +716,12 @@
         {
           G4double proCB=theEnvironment.CoulombBarrier(1,3);
-		        G4QNucleus tmpTN(totZ-1,totN-2,0);
+          G4QNucleus tmpTN(totZ-1,totN-2,0);
           G4double delT=tmpTN.GetMZNS()+mTrit-totM+proCB;
           if(envN>1&&envZ>0&&envA>3)
           {
-		          G4QNucleus envTN(envZ-1,envN-2,0);
+            G4QNucleus envTN(envZ-1,envN-2,0);
             G4double delET=envTN.GetMZNS()+mTrit-envM+proCB;
             if(delET>delT) delT=delET;
-		        }
+          }
           delT*=qurF;
           if(delT<minK) minK=delT;
@@ -709,12 +730,12 @@
         {
           G4double proCB=theEnvironment.CoulombBarrier(2,3);
-		        G4QNucleus tmpRN(totZ-2,totN-1,0);
+          G4QNucleus tmpRN(totZ-2,totN-1,0);
           G4double delR=tmpRN.GetMZNS()+mHel3-totM+proCB;
           if(envN>0&&envZ>1&&envA>3)
           {
-		          G4QNucleus envRN(envZ-2,envN-1,0);
+            G4QNucleus envRN(envZ-2,envN-1,0);
             G4double delER=envRN.GetMZNS()+mHel3-envM+proCB;
             if(delER>delR) delR=delER;
-		        }
+          }
           delR*=qurF;
           if(delR<minK) minK=delR;
@@ -723,12 +744,12 @@
         {
           G4double proCB=theEnvironment.CoulombBarrier(2,4);
-		        G4QNucleus tmpAN(totZ-2,totN-2,0);
+          G4QNucleus tmpAN(totZ-2,totN-2,0);
           G4double delA=tmpAN.GetMZNS()+mAlph-totM+proCB;
           if(envN>1&&envZ>1&&envA>4)
           {
-		          G4QNucleus envAN(envZ-2,envN-2,0);
+            G4QNucleus envAN(envZ-2,envN-2,0);
             G4double delEA=envAN.GetMZNS()+mAlph-envM+proCB;
             if(delEA>delA) delA=delEA;
-		        }
+          }
           delA*=qurF;
           if(delA*qurF<minK) minK=delA*qurF;
@@ -738,34 +759,34 @@
         //{
         //  G4double proCB=theEnvironment.CoulombBarrier(3,6);
-		      //  G4QNucleus tmpLN(totZ-3,totN-3,0);
+        //  G4QNucleus tmpLN(totZ-3,totN-3,0);
         //  G4double delL=tmpLN.GetMZNS()+mLit6-totM+proCB;
         //  if(envN>2&&envZ>2&&envA>6)
         //  {
-		      //    G4QNucleus envLN(envZ-3,envN-3,0);
+        //    G4QNucleus envLN(envZ-3,envN-3,0);
         //    G4double delEL=envLN.GetMZNS()+mLit6-envM+proCB;
         //    if(delEL>delL) delL=delEL;
-		      //  }
+        //  }
         //  delL*=qurF;
         //  if(delL<minK) minK=delL;
         //}
         if(minK<0.||minK+minK>quasM) minK=0.;
-	     }
+      }
       //if(addPhoton>0.&&quasM<1500.&&G4UniformRand()<f2all)
-	     //if(addPhoton>0.&&iniBN<2)// PhotonAbsorbDiagramContrib(@@HiddenPar)
-	     //if(addPhoton>0.&&(G4UniformRand()<.7||iniBN<2))//PhotoAbsorbDiagramContrib
-	     //if(addPhoton>0.&&(G4UniformRand()<.5||iniBN<2))//PhotonAbsorbDiagramContrib
+      //if(addPhoton>0.&&iniBN<2)// PhotonAbsorbDiagramContrib(@@HiddenPar)
+      //if(addPhoton>0.&&(G4UniformRand()<.7||iniBN<2))//PhotoAbsorbDiagramContrib
+      //if(addPhoton>0.&&(G4UniformRand()<.5||iniBN<2))//PhotonAbsorbDiagramContrib
       //if(addPhoton>0.&&(G4UniformRand()<.27||iniBN<2))// PhotonAbsorbDiagramContrib
-	     //if(addPhoton>0.&&iniBN<2)// PhotonAbsorbDiagramContrib(@@HiddenPar)
-	     //if(addPhoton>0.&&iniBN>1)// PhotonAbsorbDiagramContrib(@@HiddenPar)
-	     //if(addPhoton>0.&&G4UniformRand()<0.5)// PhotonAbsorbDiagramContrib(@@HiddenPar)
-	     //if(addPhoton>0.&&G4UniformRand()<0.75)// PhotonAbsorbDiagramContrib(@@HiddenPar)
-	     ///if(addPhoton>0.&&G4UniformRand()<0.8)// PhotonAbsorbDiagramContrib(@@HiddenPar)
-	     //if(addPhoton>0.&&iniBN>1)//PhotonAbsorbDiagramContrib(Photon's captured by N quark)
-	     if(addPhoton>0.)// PhotonAbsorbDiagramContrib(Photon is always captured by quarks)
-	     //if(2>3)                              // Photon capture by quark is closed
+      //if(addPhoton>0.&&iniBN<2)// PhotonAbsorbDiagramContrib(@@HiddenPar)
+      //if(addPhoton>0.&&iniBN>1)// PhotonAbsorbDiagramContrib(@@HiddenPar)
+      //if(addPhoton>0.&&G4UniformRand()<0.5)// PhotonAbsorbDiagramContrib(@@HiddenPar)
+      //if(addPhoton>0.&&G4UniformRand()<0.75)// PhotonAbsorbDiagramContrib(@@HiddenPar)
+      ///if(addPhoton>0.&&G4UniformRand()<0.8)// PhotonAbsorbDiagramContrib(@@HiddenPar)
+      //if(addPhoton>0.&&iniBN>1)//PhotonAbsorbDiagramContrib(Photon's captured by N quark)
+      if(addPhoton>0.)// PhotonAbsorbDiagramContrib(Photon is always captured by quarks)
+      //if(2>3)                              // Photon capture by quark is closed
       {
         //nOfQ=valQ.GetQ()-valQ.GetAQ();     // Recover nOfQ for the not excited cluster
         // @@ 1/(p_g,p_q) interaction probability (? (p_g,p_q)=0 always)
-	       gintFlag=true;
+        gintFlag=true;
         q4Mom-= phot4M;                    // recover Quasmon-Cluster without the Photon
         qM2   = q4Mom.m2();                // Update the Current squared mass of Quasmon 
@@ -779,8 +800,8 @@
         //G4int cMax=27;//For m_gam=0:*[k/(k+p) factor 1/s{m<<k,s=m^2*(1+p/k)}]*[p/k(ct=0)]
         //G4int pCount=0;//For m_gam=0 the suppression factor can be p*p/(p+k)/(p+k) @@ (?)
-		      //while (frat && pCount<cMax)
+        //while (frat && pCount<cMax)
         //{
-		      // ____ Keep this when closing while______________________________
-		      G4double rn=G4UniformRand(); // k is changed by addPhoton
+        // ____ Keep this when closing while______________________________
+        G4double rn=G4UniformRand(); // k is changed by addPhoton
         kMom=(1.-(1.-xmi)*pow(rn,1./kpow))*quasM/2; // 1/k from delta-funct integration
         // ----------
@@ -788,20 +809,20 @@
         G4double dkM=kMom+kMom;
         // p2+k2+2pkcost=(k+e)2
-	       //cost=(addPhoton*addPhoton-momPhoton*momPhoton+addPhoton*dkM)/momPhoton/dkM;
+        //cost=(addPhoton*addPhoton-momPhoton*momPhoton+addPhoton*dkM)/momPhoton/dkM;
         G4double cor=200./dkM/addPhoton;
         G4double bas=std::log(2+cor);
-	       cost=1.-std::exp(bas-(bas-std::log(cor))*G4UniformRand());
-	       //cost=1.-2*G4UniformRand();
-		      // ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
-		      //  frat=G4UniformRand()>kMom/(addPhoton+kMom);
-		      //  //frat=G4UniformRand()>kMom*kMom/(addPhoton+kMom)/(addPhoton+kMom);
+        cost=1.-std::exp(bas-(bas-std::log(cor))*G4UniformRand());
+        //cost=1.-2*G4UniformRand();
+        // ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+        //  frat=G4UniformRand()>kMom/(addPhoton+kMom);
+        //  //frat=G4UniformRand()>kMom*kMom/(addPhoton+kMom)/(addPhoton+kMom);
         //  //frat=G4UniformRand()>addPhoton/(addPhoton+kMom);
         //  //frat=G4UniformRand()>addPhoton*addPhoton/(addPhoton+kMom)/(addPhoton+kMom);
         //  pCount++;
-		      //}
+        //}
         if(cost>1.) cost=1.;
         if(cost<-1.) cost=-1.;
 #ifdef debug
-	       G4cout<<"G4Q::HQ:**PHOTON out of Q**k="<<kMom<<",ct="<<cost<<",QM="<<quasM<<G4endl;
+        G4cout<<"G4Q::HQ:**PHOTON out of Q**k="<<kMom<<",ct="<<cost<<",QM="<<quasM<<G4endl;
 #endif
         // @@ (?) Pseudo Fermi-mom correction (use lib function for the 3d randomization -*
@@ -834,9 +855,9 @@
         //cost-=dc;                                  // for virtPhotons smear in both dir.|
         // --- Quark mass correction ends here (?) ---------------------------------------*
-	     }
+      }
       else
-	     {
-		      gaF=false;                         // GammaFirstAct flag is only for the gamma-q
-	       gintFlag=false;
+      {
+        gaF=false;                         // GammaFirstAct flag is only for the gamma-q
+        gintFlag=false;
         // ==== Probabiliti proportional to k (without 1/k factor of hadronization)
         if(!miM2) miM2=(minK+minK)*quasM; // Make minimum mass for randomization
@@ -846,5 +867,5 @@
         //G4double kpow=static_cast<double>(nOfQ-2);
         //G4double kst=0.;
-		      //if(maxK+maxK<quasM+.1) kst=pow((1.-(maxK+maxK)/quasM),kpow);
+        //if(maxK+maxK<quasM+.1) kst=pow((1.-(maxK+maxK)/quasM),kpow);
         //if(maxK>minK)
         //{
@@ -856,16 +877,16 @@
         G4double rnc=G4UniformRand();
         cost = 1.-rnc-rnc;
-	     }
+      }
       G4double cQM2=qM2-(kMom+kMom)*quasM;
       if(cQM2<0.)
-	     {
+      {
         //if(cQM2<-.0001)G4cerr<<"--Warning--G4Q::HQ:(PhBack) cQM2="<<cQM2<<" < 0"<<G4endl;
         cQM2=0.;
-	     }
+      }
       G4double cQM=sqrt(cQM2);             // Mass of the coloured residual Quasmom
       k4Mom=zeroLV;
       cr4Mom=G4LorentzVector(0.,0.,0.,cQM);
       G4LorentzVector dir4M=q4Mom-G4LorentzVector(0.,0.,0.,q4Mom.e()*.01);
-	     if(!G4QHadron(q4Mom).RelDecayIn2(k4Mom,cr4Mom,dir4M,cost,cost)) //Q->ColResQ+k_part
+      if(!G4QHadron(q4Mom).RelDecayIn2(k4Mom,cr4Mom,dir4M,cost,cost)) //Q->ColResQ+k_part
       {
 #ifdef debug
@@ -884,5 +905,5 @@
           }
           gintFlag=false; 
-		      }
+        }
       }
       else                                  // ***> The decay succeeded
@@ -896,7 +917,7 @@
           kMom=k4Mom.e();                   // Update the k_parton momentum
           gintFlag=false; 
-		      }
-#ifdef debug
-	       G4cout<<"G4Q::HQ:(PhBack) k="<<kMom<<",k4M="<<k4Mom<<",ct="<<cost<<",gF="<<gintFlag
+        }
+#ifdef debug
+        G4cout<<"G4Q::HQ:(PhBack) k="<<kMom<<",k4M="<<k4Mom<<",ct="<<cost<<",gF="<<gintFlag
               <<G4endl;
 #endif
@@ -907,5 +928,5 @@
         G4int totCand = theQCandidates.size(); // Total number of candidates
 #ifdef sdebug
-	       G4cout<<"G4Q::HQ: ***>>>K-ITERATION #"<<kCount<<", k="<<kMom<<k4Mom<<G4endl;
+        G4cout<<"G4Q::HQ: ***>>>K-ITERATION #"<<kCount<<", k="<<kMom<<k4Mom<<G4endl;
 #endif
         for (G4int index=0; index<totCand; index++)
@@ -917,8 +938,8 @@
             G4bool poss= curCand->GetPossibility();
 #ifdef debug
-		          if(cPDG==90000001 || cPDG==90001000 || cPDG==90000002 || cPDG==90001001)
-	             G4cout<<"G4Q::HQ:pos="<<poss<<",cPDG="<<cPDG<<",iQC="<<iniQChg<<G4endl;
-#endif
-		          if(poss)
+            if(cPDG==90000001 || cPDG==90001000 || cPDG==90000002 || cPDG==90001001)
+              G4cout<<"G4Q::HQ:pos="<<poss<<",cPDG="<<cPDG<<",iQC="<<iniQChg<<G4endl;
+#endif
+            if(poss)
             {
               G4double   cMs=curCand->GetEBMass(); // EnvBound mass of the ParentCluster(?)
@@ -931,6 +952,6 @@
               //////////////////G4double pmk  = rMo*cMs/kLS;
 #ifdef debug
-		            if(cPDG==90000001 || cPDG==90001000 || cPDG==90000002 || cPDG==90001001)
-			             G4cout<<"G4Q::HQ:cfM="<<cfM<<",cMs="<<cMs<<",ind="<<index<<G4endl;
+              if(cPDG==90000001 || cPDG==90001000 || cPDG==90000002 || cPDG==90001001)
+                G4cout<<"G4Q::HQ:cfM="<<cfM<<",cMs="<<cMs<<",ind="<<index<<G4endl;
 #endif
               G4double k = kMom;
@@ -946,23 +967,23 @@
               //if (dR<0.) dR=0.;
               G4double dR=0.;               // @@ Temporary no q-acceleration cut is used
-     		       if(cPDG==90000001 || cPDG==90001000 || cPDG==90000002 || cPDG==90001001)
-	              G4cout<<"G4Q::HQ:i="<<index<<",cPDG="<<cPDG<<",k="<<kMom<<","<<kLS<<">kMin="
+              if(cPDG==90000001 || cPDG==90001000 || cPDG==90000002 || cPDG==90001001)
+               G4cout<<"G4Q::HQ:i="<<index<<",cPDG="<<cPDG<<",k="<<kMom<<","<<kLS<<">kMin="
                      <<kMin<<",bM="<<bnM<<",rEP="<<rEP<<",dR="<<dR<<",kCo="<<kCond<<G4endl;
 #endif
               if(kLS>kMin)
-			           {
+              {
                 kCond=false;
                 break;
               }
-		          }
-		        }
-	       }
-	     }
+            }
+          }
+        }
+      }
       kCount++;
-	   }
+    }
     // End of search for "k": *** Here we forget about the initial photon forever ***???***
 #ifdef debug
     if(addPhoton)
-	     G4cout<<"G4Q::HQ:***PHOTON OK***k="<<k4Mom<<",Q="<<q4Mom<<",PhE="<<addPhoton<<G4endl;
+      G4cout<<"G4Q::HQ:***PHOTON OK***k="<<k4Mom<<",Q="<<q4Mom<<",PhE="<<addPhoton<<G4endl;
 #endif
     //if(gintFlag)kLS-=addPhoton;           // @@ correct for the virtual (?) -*
@@ -990,5 +1011,5 @@
     {
 #ifdef debug
-	     if(status==4)throw G4QException("G4Q::HQ:*TMP EXCEPTION - NoChanalsOfFragmentation");
+      if(status==4)throw G4QException("G4Q::HQ:*TMP EXCEPTION - NoChanalsOfFragmentation");
 #endif
 #ifdef debug
@@ -1007,6 +1028,6 @@
       // @@ practically never is here
       if(!first&&excE>qCB&&envM+iniQM<totMass&&nQuasms==1&&qenv&&G4UniformRand()<pCB)
-	     //if(2>3)                               // Decay in GSQuasmon+GSEnviron **Is closed**
-	     {
+      //if(2>3)                               // Decay in GSQuasmon+GSEnviron **Is closed**
+      {
         G4QHadron* resNuc = new G4QHadron(valQ,q4Mom);// Createa Hadron for Quasmon
         resNuc->CorMDecayIn2(iniQM,env4M);  // Recalculate the fr4Mom for ResidualGSMass
@@ -1023,5 +1044,5 @@
           FillHadronVector(envH);           // Fill Moving Environment (delete equivalent)
           qEnv = vacuum;
-		      }
+        }
 #ifdef debug
         G4double eM=env4M.m();
@@ -1031,7 +1052,7 @@
         ClearQuasmon();                     // This Quasmon is done
         return theQHadrons;                 // The last decay of the quasmon...
-	     }
+      }
       else                                  // May be evaporation is possible
-	     {
+      {
 #ifdef debug
         G4cout<<"G4Q::HQ:Q2E:E="<<theEnvironment<<",valQ="<<valQ<<",tot4M="<<tot4M<<G4endl;
@@ -1040,6 +1061,6 @@
         if(CheckGroundState(true)) ClearQuasmon(); // This Quasmon is done
         //if(CheckGroundState(true)) KillQuasmon(); // This Quasmon is done
-		      //else if(envPDG==NUCPDG && quasM>iniQM && iniBN>1) // Convert Quasmon to MovingEnv
-		      //{
+        //else if(envPDG==NUCPDG && quasM>iniQM && iniBN>1) // Convert Quasmon to MovingEnv
+        //{
 #ifdef debug
         //  G4cerr<<"***G4Q::HQ:Q2E="<<theEnvironment<<",QC="<<valQ<<",4M="<<tot4M<<G4endl;
@@ -1047,7 +1068,7 @@
         //  theEnvironment=G4QNucleus(valQ,tot4M);
         //  KillQuasmon();
-		      //}
-		      else if(envPDG==NUCPDG && quasM>iniQM) // Emergency decay in Gamma & GSQuasmon
-		      {
+        //}
+        else if(envPDG==NUCPDG && quasM>iniQM) // Emergency decay in Gamma & GSQuasmon
+        {
 #ifdef debug
           G4cout<<"***G4Q::HQ: Emergency Decay in Gamma/Pi0 + Residual GSQuasmon"<<G4endl;
@@ -1057,13 +1078,13 @@
           G4double gamM=0.;
           if(quasM>mPi0+iniQM)
-		        {
+          {
             gamPDG=111;
             gamM=mPi0;
-		        }
+          }
           G4LorentzVector r4Mom(0.,0.,0.,gamM);  // mass of the photon/Pi0
           G4LorentzVector s4Mom(0.,0.,0.,iniQM); // mass of the GSQuasmon
           G4double sum=gamM+iniQM;
           if(sum>0. && fabs(quasM-sum)<eps)
-		        {
+          {
              r4Mom=q4Mom*(gamM/sum);
              s4Mom=q4Mom*(iniQM/sum);
@@ -1072,9 +1093,9 @@
           {
             G4cerr<<"***G4Q::HQ:Q="<<q4Mom<<quasM<<"->g/pi0(M="<<gamM<<")+GSQ="<<iniPDG
-				              <<"(M="<<iniQM<<")="<<sum<<", d="<<sum-quasM<<G4endl;
-    	       throw G4QException("G4Quasmon::HadronizeQ:(E=0)G/Pi0+GSQ decay error");
-          }
-#ifdef debug
-	         G4cout<<"G4Q::HQ:=== 0 ===>HadrVec, Q="<<q4Mom<<quasM<<"->g/pi0("<<gamPDG<<")="
+                  <<"(M="<<iniQM<<")="<<sum<<", d="<<sum-quasM<<G4endl;
+            throw G4QException("G4Quasmon::HadronizeQ:(E=0)G/Pi0+GSQ decay error");
+          }
+#ifdef debug
+          G4cout<<"G4Q::HQ:=== 0 ===>HadrVec, Q="<<q4Mom<<quasM<<"->g/pi0("<<gamPDG<<")="
                 <<r4Mom<<gamM<<"+GSQ="<<iniPDG<<r4Mom<<iniQM<<G4endl;
 #endif
@@ -1084,12 +1105,12 @@
           FillHadronVector(curHadr1);       // Fill "new curHadr1" (delete equivalent)
           ClearQuasmon();                   // This Quasmon is done
-		      }
-#ifdef pdebug
-	       G4cout<<"***G4Q::HQ:dE="<<excE<<">minK="<<minK<<",Env="<<theEnvironment<<",k="<<kLS
+        }
+#ifdef pdebug
+        G4cout<<"***G4Q::HQ:dE="<<excE<<">minK="<<minK<<",Env="<<theEnvironment<<",k="<<kLS
               <<",Q="<<valQ<<quasM<<", nQ="<<nQuasms<<G4endl;
 #endif
         qEnv=theEnvironment;
         return theQHadrons;
-	     }
+      }
     }
     G4bool nucflag=false;                   // NuclearBinding Flag (can't reduce Environ)
@@ -1145,8 +1166,8 @@
         G4cerr<<"***G4Q::HQ: Cand#"<<i<<" >= Tot#"<<nCandid<<G4endl;
         throw G4QException("G4Quasmon::HadronizeQuasmon: Too big number of the candidate");
-	     }
+      }
       curQ = valQ;                            // Temporary copy of valQ to estimate MinM2
-						if (!fprob)  // At present is closed    // Prepare final decay (nothing was selected)
-	     {
+      if (!fprob)  // At present is closed    // Prepare final decay (nothing was selected)
+      {
         memQ=curQ;                            // Remembe QC for the case of 2H decay
         sPDG=curQ.GetSPDGCode();              // PDG of current Quasmon as S-hadron
@@ -1161,10 +1182,10 @@
         }
         else if(!sPDG)
-	       {
+        {
           G4cerr<<"**G4Q::HQ:sPDG=0,E="<<theEnvironment<<",B="<<totBN<<",S="<<totS<<G4endl;
           throw G4QException("G4Quasmon::HadronizeQuasmon:DecayPartSelection,Evaporation");
-	       }
+        }
         else if(sPDG==10)                     // ---> "Chipolino" case
-	       {
+        {
           fchipo=true;
           G4QChipolino chipQ(valQ);
@@ -1176,7 +1197,7 @@
           rMass= QPDG2.GetMass();
           if(sMass+rMass>quasM)               //@@ Evaporate but try 3Pt decay with Environ
-		        {
-		          if(totBN>1&&totMass>totM&&totS>=0)
-		          {
+          {
+            if(totBN>1&&totMass>totM&&totS>=0)
+            {
 #ifdef ppdebug
               G4cout<<"G4Q::HQ:NEED-EVAP-2:Q="<<q4Mom<<valQ<<",E="<<theEnvironment<<G4endl;
@@ -1185,12 +1206,12 @@
               qEnv=theEnvironment;
               return theQHadrons;
-		          }
+            }
             else
-		          {
+            {
               G4cerr<<"***G4Q::HQ:QM="<<quasM<<"<S="<<sMass<<"+R="<<rMass<<"="<<sMass+rMass
                     <<",tB="<<totBN<<",tS="<<totS<<",tM="<<totMass<<">minM="<<totM<<G4endl;
               throw G4QException("G4Quasmon::HadronizeQuasmon:VirtChipo Can'tEvapNucleus");
-		          }
-		        }
+            }
+          }
         }
         else if(nQuasms>1)
@@ -1208,5 +1229,5 @@
           rPDG=envPDG;
           if (rPDG>MINPDG&&rPDG!=NUCPDG)
-	         {
+          {
             rMass=theEnvironment.GetMZNS();
             q4Mom+=G4LorentzVector(0.,0.,0.,rMass);
@@ -1215,7 +1236,7 @@
             KillEnvironment();
             fred=true;                        // Flag of environment reduction
-	         }
+          }
           else if(rPDG!=NUCPDG&&totBN>1&&totMass>totM&&totS>=0)  // ===> "Evaporation" case
-	         {
+          {
 #ifdef ppdebug
             G4QContent nTotQC=totQC-neutQC;
@@ -1233,5 +1254,5 @@
             qEnv=theEnvironment;
             return theQHadrons;
-	         }
+          }
           else if(rPDG==NUCPDG)
           {
